#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')

contentheader = 'Content-Type: text/html; charset=utf-8'

mainpage = '''<html><head><title>Receiving a \
  Form</title>\n<meta http-equiv="refresh" content="1; URL=patient_main.py?patient_id=%s">\n</head><body>%s</body></html>'''
error = '''<h1>Error</h1><h2>No Form Submission Was Received</h2>'''
result = '''<h1>Заключение</h1>
<p>Получены следующие данные:</p>

%s
'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                # finish headers with blank line

    theform = cgi.FieldStorage()
    

    surname = string_filter(theform.getfirst('surname', 'NONAME'))
    name = string_filter(theform.getfirst('name', 'NONAME'))
    otchestvo = string_filter(theform.getfirst('otchestvo', ''))
    gender = string_filter(theform.getfirst('gender', '-'))
    day = theform.getfirst('day', '99')
    month = theform.getfirst('month', '99')
    year = theform.getfirst('year', '9999')
    adres = string_filter(theform.getfirst('adres', ''))
    telefon = string_filter(theform.getfirst('telefon', ''))
    diagnosis = string_filter(theform.getfirst('diagnosis', ''))
    comments = string_filter(theform.getfirst('comments', ''))
    tags = string_filter(theform.getfirst('tags', ''))
    
    date = string_filter(year+month+day)
    

    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()
    
    

    
    insert_data = '''INSERT INTO patients (id, surname, name, otchestvo, gender, 
                                           birthdate, adres, telefon, diagnosis,
                                           tags, comments, deleted)
                             values (null, "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", 5)
    '''
    cursor.execute(insert_data % (surname, name, otchestvo, gender, date, adres, telefon, diagnosis, \
        tags, comments))
    
    connection.commit()
    
    cursor.execute('SELECT id FROM patients WHERE deleted=5')
    patient_id=cursor.fetchone()[0]
    cursor.execute('UPDATE patients SET deleted=0 WHERE id=%s' % patient_id)
    connection.commit()
    connection.close()

    results = 'Добавлен больной:\n\
        Ф.И.О.: %s %s %s \n<br>Пол: %s\n<br>Дата рождения: %s/%s/%s\n<br>Адрес: %s\n<br>Телефон: %s\n\
        <br>Диагноз: %s\n <br>Комментарии: %s\n<br>Теги: %s'
    
          
    body = result % (results % (surname, name, otchestvo, gender, day, month, year, adres, telefon, diagnosis, \
        comments, tags))

    print mainpage % (patient_id, body)
    
