#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import cgi
import sys

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'
gotoexam='''<script language="JavaScript" type="text/JavaScript">
function goToExams(id){
	document.location.href = "patient_main.py?patient_id=" + id;
}
</script>
'''



if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line
    
    theform = cgi.FieldStorage()
    searc = unicode(theform.getfirst('search', ''), 'utf-8')
    search = searc[0:1].upper() + searc[1:]
    tags_post = unicode(theform.getfirst('tags', ''), 'utf-8').replace('"', '')
    tags_and = theform.getfirst('tags_and', 0)

    tags = tags_post.split(' ')
    tags_search=[]
    tags_query=''
    if tags_and==0: tags_conj = 'AND'
    else: tags_conj = 'OR'
    
    if tags!=['']:
        for tag in tags:
            tags_search.append('tags LIKE "%' + tag + '%"')
            tags_search.append(tags_conj)
        tags_search.pop()
        tags_query = 'AND (%s)' % ' '.join(tags_search)


    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    query = 'SELECT * FROM patients WHERE deleted=0 AND surname LIKE "%s%%" %s ORDER BY surname, name, otchestvo'

    query = query % (search.replace('"', '""'), tags_query) 

    

    cursor.execute(query)

    data = cursor.fetchall()
    connection.close()
    
    
    print '<html><head>'
    print '<title>Список пациентов</title>'
    print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
    print '</head>'
    print '<body>', gotoexam
    print '''<table><tr><td><form name="search" action="database_display.py" method="post">
Фамилия: &nbsp<input type="text" name="search" value="%s" size=32>''' % search.encode('utf-8')
    print '''</td>'''
    print '''<td>Теги: &nbsp<input type="text" name="tags" value="%s" size=32>''' % tags_post.encode('utf-8')

    print '<input type="checkbox" name="tags_and" value=1 %s>' % ['', 'checked="checked"'][int(tags_and)]  
    print '''</td><td><input type="submit" value="поиск"></td>
   

<td><INPUT TYPE="button" VALUE="Добавить пациента" onClick="parent.location='add_new_patient.py'">\
	</FORM></td></tr></table>''' 
    print '<table><tr><th>Ф. И. О. (%s)</th><th>Дата рождения</th><th>Теги</th><th>' % len(data)
    
    rowhead = '''<tr onmouseover="this.style.backgroundColor='#BED9FB';" \
       onmouseout = "this.style.backgroundColor='#E5E5E5';" onclick="goToExams(%d)">'''    

    for row in data:
        print rowhead % row[0]
        print ('<td>'+' '.join(row[1:4])+'</td>').encode('utf-8')
        print '<td>', '%s/%s/%s' % (row[5][6:8], row[5][4:6], row[5][0:4]), '</td>'
        print '<td>', unicode(row[9]).encode('utf-8'), '</td>'



    
    cgiprint('</table></body></html>')


