#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite

import sys
import cgi
try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def re_string_filter(s=''):
    return s.replace('""', '"').replace('&lt;', '<').replace('&gt;', '>').replace('&amp;', '&')


contentheader = 'Content-Type: text/html; charset=utf-8'


thepage = '''<html><head>
<title>%s</title>
<script language="JavaScript" type="text/JavaScript">
<!--
function uncheckRadio(choice) {
/* var choice = document.form1.RadioGroup1;*/
 for (i = 0; i < choice.length; i++) {
  if ( choice[i].checked = true ) 
   choice[i].checked = false; 
 }
}
//-->
</script>
</head><body>
%s
</body></html>
'''
h1 = '<h1>%s</h1>'





form = '''<form name="form" action="/cgi-bin/form_process.py" target="_top" method="post">
%s
<input type="reset" value="Очистить форму" />
<input type="submit" value="Отправить данные"/>
</form>
'''


if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    title = 'Эходата'
    headline = h1 % 'Эходата' + form
    
    theform = cgi.FieldStorage()
    
    form_id = theform.getfirst('form_id', 0)
    patient_id = theform.getfirst('patient_id', 0)
    examdate = theform.getfirst('examdate', '19000101')
    physician = theform.getfirst('physician', '')

    connection = sqlite.connect('config.db')
    cursor = connection.cursor()
    
    cursor.execute('SELECT name, contents FROM forms WHERE id=%s' % form_id) 
    
    data = cursor.fetchone()

    contents = re_string_filter(data[1])
    contents = contents + ('\np\n+Врач '+physician+'\n').decode('utf-8')

    name = data[0]
    connection.close()
    
    f=contents.split('\n')

    formstring='<p>'

    theinput='<br><label><input type="%s" name="%s" value="%s" id="%s">&nbsp;%s</label>'
    
    hidden='<input type="hidden" name="%s" value="%s">'
    

    radioinput='<br><label><input type="radio" name="%s" value="%s" ondblclick="uncheckRadio(document.form.%s);">&nbsp;%s</label>'

    optioninput = '<option value="%s">%s</option>'
    selectinput = '<select name="%s">\n<option value="%s">%s</option>'
    
    textinput='<input type="text" name="%s" value="" size=%s>'

    textarea='<textarea name="%s" rows=%s style="width:100%%">%s</textarea>'
    last = 'b'
    i = 0
    k = 0
    titles=1
    for line in f: 
        if line=='': line='\n'
        i = i + 1
        k=k+1
        if last=='\\' and line[0]!='\\': formstring = formstring + '</select>' + '\n' 
        if line[0]=='[' or line[0]==']':
            string = hidden % ('item'+str(i), line[0])
        elif line[0]=='>' or line[0]=='<':
            string = '<br>' + hidden % ('item'+str(i), line) + line[1:]
        elif line[0]=='=':
            string = hidden % ('item'+str(i), line) + line[1:]
        elif line[0]=='+':
            string = theinput % ('checkbox', 'item'+str(i), line, 'check'+str(k), line[1:])
        elif line[0]=='-':
            if last == '-': i = i - 1
            string = radioinput % ('item'+str(i), line, 'item'+str(i), line[1:])
        elif line[0]=='#':
            string = textinput % ('item'+str(i), len(line))
        elif line[0]=='$':
            string = textarea % ('item'+str(i), int(line[1]), line[2:].strip().replace('\\', '\n'))
        elif line[0]=='\\' and last!='\\':
            string = selectinput % ('item'+str(i), line, line[1:])
        elif line[0]=='\\' and last=='\\':
            string = optioninput % (line, line[1:])
            i = i - 1
        elif line[0]=='{':
            string = '<h1><a name = "'+str(titles)+'">'+line[1:]+'</a></h1>'
            titles = titles + 1
        elif line[0]=='p':
            string = hidden % ('item'+str(i), 'p'*len(line))
        elif line[0]=='\r' or line[0]=='\n' or line[0]==' ':
            string = '<br>' + hidden % ('item'+str(i), 'p')
        else: 
            i = i - 1
            continue
        last = line[0]
        formstring = formstring + string + '\n'
    
    formstring = formstring + hidden % ('items_number', str(i)) + '\n'
    formstring = formstring + hidden % ('patient_id', patient_id) + '\n'
#    formstring = formstring + hidden % ('physician', physician) + '\n'
    formstring = formstring + hidden % ('physician', physician.decode('utf-8')) + '\n'
#    k = formstring + str(fs)
    formstring = formstring + hidden % ('name', name) + '\n'
    formstring = formstring + hidden % ('examdate', examdate) + '\n'
    print (thepage % (title, form % formstring.encode('utf-8')))

