#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import time
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'

mainpage = '''<html><head><title>Сохранение исследования</title>
<meta http-equiv="refresh" content="1; URL=patient_main.py?patient_id=%s&exam_id=%s">\n</head><body>%s</body></html>'''
error = '''<h1>Error</h1><h2>No Form Submission Was Received</h2>'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                # finish headers with blank line

    theform = cgi.FieldStorage()
    data=[]
    items_number=string_filter(theform.getfirst('items_number', '0'))
    patient_id = string_filter(theform.getfirst('patient_id', '0'))
    physician = string_filter(theform.getfirst('physician', ''))
    name = string_filter(theform.getfirst('name', 'noname'))
    examdate = string_filter(theform.getfirst('examdate', '19900101'))
    k = eval(items_number)
   
    for i in range(k): 
        value = theform.getfirst('item'+str(i+1), 'NOVALUE')
        if value!='NOVALUE': data.append(value)
    
    depth = [0]
    strings=[[]]    
    results=''
    last=' '
            
    for s in data:
        s=s.strip()
        if s=='': strings[-1].append('\n')            
        elif s[0]=='p':
            strings[-1].append('\n'*len(s))
        elif s[0]=='[': 
            depth.append(0)
            strings.append([])
        elif s[0]=='>' or s[0]=='=':
            strings[-1].append(s[1:])
        elif s[0]=='+' or s[0]=='-':
            if last=='+' or last=='\\': strings[-1][-1]=strings[-1][-1]+','	
            strings[-1].append(s[1:])
            depth[-1]=1
        elif s[0]==']':
            if depth.pop()==0: nul = strings.pop()
            else: depth[-1]=1
#            else: strings[-1].append('.\n')
        elif s[0]=='\\':
            if len(s)>1: strings[-1].append(s[1:])
        else:
            strings[-1].append(s)
            depth[-1]=1
        if s!='': last=s[0]
        else: last=' '

    results = ''
    last=''
    for ss in strings: 
        for s in ss: 
            if s!='\n': results=results+s+' '
            else: results=results+'\n'
    
    
    formatted_results = results.replace('\r', '').replace(' \n', '\n').replace('\n ', '\n').replace('\n', '.\n').replace('\n.', '\n')
    formatted_results = formatted_results.replace(',.', '.').replace('..', '.').replace(' ,', ',').replace(':,', ':')    
    formatted_results = formatted_results.replace(':.', ':').replace('"', '""')    
    formatted_results=string_filter(formatted_results)
    

    con = sqlite.connect('patients.db')
    cur = con.cursor()
        
    insert_data = '''INSERT INTO examinations (id, patient_id, examdate, name, contents, physician, deleted)
                             values (null, %s, "%s", "%s", "%s", "%s", 5)'''

    cur.execute('SELECT surname, name, otchestvo, birthdate FROM patients WHERE id=%s' % patient_id)
    patient = cur.fetchone()
    fio = ' '.join(patient[0:3]).strip().replace('"', '""').encode('utf-8')

    
    yo=(int(examdate)-int(patient[3]))/10000
    
    months=['января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', \
	'сентября', 'октября', 'ноября', 'декабря']

    data = examdate[6:8] + ' ' + months[int(examdate[4:6])-1] + ' ' + examdate[0:4] + ' г.\n'
    if yo>1: 
        let = ', ' + str(yo) + ' ' + ['лет','год','года','года','года','лет','лет','лет','лет','лет'][yo%10]+'\n\n'
    else: 
        mo = ((int(examdate)-int(patient[3]))/100+12)%100%12
        if mo>0:
            mes = str(mo%100) + ' месяц' + ['ев','','а','а','а','ев','ев','ев','ев','ев','ев','ев'][mo%100]
            let=', ' + yo*'1 год и ' + mes + '\n\n'
        else:
            days = (int(examdate)-int(patient[3]))
            if days in [1,21,31]: let = ', ' + str(days) + ' день\n\n'
            elif days in [2,3,4,22,23,24]: let = ', ' + str(days) + ' дня\n\n'
            else: let =  ', ' + str(days) + ' дней\n\n'
    cur.execute(insert_data % (patient_id, examdate, name, data+fio+let+formatted_results, physician))
    con.commit()
    cur.execute('SELECT id FROM examinations WHERE patient_id=%s AND deleted=5' % patient_id)
    data = cur.fetchone()
    if data!=None: exam_id=data[0]
    else: exam_id=''
    cur.execute('UPDATE examinations SET deleted=0 WHERE deleted=5')
    con.commit()
    con.close() 

    print mainpage % (patient_id, exam_id, 'Исследование добавляется, подождите...')
    
