#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')

contentheader = 'Content-Type: text/html; charset=utf-8'
body = '''<html><head><title></title></head><body>%s</body></html>'''
script='''<script language="JavaScript" type="text/JavaScript">
function place_exam(pat, ex){
	parent.edit.location.href = "exam_edit.py?patient_id=" + pat + "&exam_id=" + ex;
}
</script>
'''


patient=None
hospital=1
if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    hosp = int(theform.getfirst('hosp', 2)) # 2 for no action

    patient_id = string_filter(theform.getfirst('patient_id', 'nopatient'))
    if patient_id == 0: print body % ('Error', 'No patient selected.')
    
    config_con = sqlite.connect('config.db')
    config_cur = config_con.cursor()
    config_cur.execute('SELECT param FROM config WHERE user="hospital"')
    for h in config_cur.fetchall(): hospital = h[0]
    config_cur.execute('SELECT * FROM hospital')
    rooms=config_cur.fetchall()
    config_con.close()

    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    if hosp==0:
        cursor.execute('UPDATE inpatients SET discharged=1 WHERE patient_id=%s' % patient_id)
        connection.commit()

    if hosp==5:                 # hospitalize in room
        room = string_filter(theform.getfirst('room', 'noroom'))
        if room!='noroom':
            query = 'INSERT INTO inpatients (patient_id, ward, room, discharged) VALUES ("%s", "%s", "%s", 0)'
            query1 = query % (patient_id, room.split(':')[0], room.split(':')[1])
            print query1
            cursor.execute(query1)
        connection.commit()


    if hosp==1:                 # Выбор палаты
        roomselect=''
        wards=set([r[0] for r in rooms])
        for w in wards:
            roomselect=roomselect + '<p>' + w + '</br>\n'+\
             '</br>'.join(['<label><input type="radio" name="room" value="%s"> %s </label>' % (r[0]+':'+r[1],r[1]) for r in filter(lambda x: x[0]==w, rooms)]) 
            
            

        
        

    cursor.execute('SELECT patient_id FROM inpatients WHERE discharged=0')
    inpatients=cursor.fetchall()
    cursor.execute('SELECT * FROM patients WHERE id=%s' % patient_id)
    
    patient=cursor.fetchone()
        
if patient!=None and hosp!=1:
    cursor.execute('SELECT * FROM examinations WHERE patient_id=%s AND deleted=0 ORDER BY examdate DESC, id DESC' % patient_id)
    exams = cursor.fetchall()

        
    connection.close()
    print '<html><head>'
    print '<title></title>'
    print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
    print script
    print '</head>'
    print '<body>'
    print '''<A TARGET = "edit" HREF="patient_edit.py?patient_id=%s">''' % patient_id
    print ('<h2>' + ' '.join(patient[1:4]) + '</h2></A>').encode('utf-8')
    print '''<FORM><INPUT TYPE="button" VALUE="Посмотреть/изменить данные"\
          onClick="parent.edit.location.href='patient_edit.py?patient_id=%s'">''' % patient_id
    print '''<input type="button" value="Добавить исследование" \ 
          onClick="parent.location='add_new_study.py?patient_id=%s'">''' % patient_id
    print '''<input type="button" value="Консультация (чистая)" \ 
          onClick="parent.edit.location.href='add_new_empty_study.py?patient_id=%s'">''' % patient_id
    print '''<input type="button" value="Удалить пациента" \ 
          onClick="parent.location='patient_remove.py?patient_id=%s'">''' % patient_id

# Hospitalization button
    if hospital!=0:
        if (int(patient_id),) in inpatients:
            print '''<input type="button" value="Выписать" \ 
              onClick="parent.exams.location='patient_display.py?patient_id=%s&hosp=0'">''' % patient_id
        else:
            print '''<input type="button" value="Госпитализировать" \ 
              onClick="parent.exams.location='patient_display.py?patient_id=%s&hosp=1'">''' % patient_id
# end of hospitalization button

    print '''<input type="button" value="Список пациентов" \ 
          onClick="parent.location='database_display.py'"></form>'''
    
    
    if exams==[]: print 'Исследований нет'
    else:
        print '<table><tr><th>Исследование</th><th>Дата</th><th>Врач</th><th>'
    
        rowhead = '''<tr onmouseover="this.style.backgroundColor='#BED9FB';" \
           onmouseout = "this.style.backgroundColor='#E5E5E5';" onclick="place_exam(%s, %s)">'''    

    for exam in exams:
        print rowhead % (patient_id, exam[0])
        print ('<td>' + exam[3] + '</td>').encode('utf-8')
        print '<td>', '%s/%s/%s' % (exam[2][6:8], exam[2][4:6], exam[2][0:4]), '</td>'
        if exam[5]!=None: print ('<td>' + exam[5] + '</td>').encode('utf-8')
        else: print '<td></td>'


    
    print '</table></body></html>'
elif hosp==1: 
  if roomselect == '': print body % 'Не задана структура отделения'
  else: 
     form = '<form action "/cgi-bin/patient_display.py" method="post">'
     form = form + roomselect.encode('utf-8')
     form = form + '<input type = "hidden" value = "5" name="hosp">'
     form = form + '<input type = "hidden" value = %s name="patient_id">' % patient_id
     form = form + '<p><input type="submit" value="Госпитализировать"></form>'
     print body % form

else: print body % 'Пациент не выбран'
