#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def date_form(year=1978, month=7, day=18):

    option='<option value="%s">%s</option>'
    selected_option='<option value="%s" selected="selected">%s</option>'

    year_options=''
    month_options=''
    day_options=''
    months=['января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', \
	'сентября', 'октября', 'ноября', 'декабря']

    for i in range(year-10, year+10):
        if i == year: year_options=year_options+ selected_option % (i,i)
        else: year_options=year_options+ option % (i,i)

    for i in range(1,13):
        if i == month: month_options=month_options+ selected_option % ('%02d' % i, months[i-1])
        else: month_options=month_options+ option % ('%02d' % i, months[i-1])

    for i in range(1,32):
        if i==day: day_options = day_options + selected_option % ('%02d' % i, i)
        else: day_options = day_options + option % ('%02d' % i, i)

    d_form='<select name="day">' + day_options + '</select>\n' + \
     '<select name="month">' + month_options + '</select>\n' + \
     '<select name="year">' + year_options + '</select>\n'

    return d_form

contentheader = 'Content-Type: text/html; charset=utf-8'
body = '''<html><head></head><body>%s</body></html>'''

patient_form='''<form name="form" action="/cgi-bin/patient_update.py" method="post">
<input type="hidden" name="patient_id" value=%(patient_id)s>
<table border=0>
<tr><td>Фамилия: &nbsp; </td><td> <input type="text" name="surname" value="%(surname)s" style="width:100%%;"> </td></tr>

<tr><td>Имя: &nbsp; </td><td> <input type="text" name="name" value="%(name)s" style="width:100%%;"> </td></tr>

<tr><td>Отчество:&nbsp;</td><td> <input type="text" name="otchestvo" value="%(otchestvo)s" style="width:100%%;"> </td></tr>

<tr><td>Пол: &nbsp; </td><td> <select name="gender">
	<option value="-" %(nogender)s></option>
	<option value="м" %(male)s>мужской</option>
	<option value="ж" %(female)s>женский</option>
	</select></td></tr>

<tr><td>Дата рождения:&nbsp;</td><td>%(dateform)s</td></tr>

<tr><td>Адрес: &nbsp; </td><td> <textarea name="adres" rows=3 style="width:100%%;">%(adres)s</textarea></td></tr>

<tr><td>Телефон: &nbsp; </td><td> <input type="text" name="telefon" value="%(telefon)s" style="width:100%%;"> </td></tr>

<tr><td>Диагноз: &nbsp; </td><td> <textarea name="diagnosis" rows=3 style="width:100%%;">%(diagnosis)s</textarea></td></tr>

<tr><td>Комментарии: &nbsp;</td><td><textarea name="comments" rows=3 style="width:100%%;">%(comments)s</textarea></td></tr>

<tr><td>Теги: &nbsp; </td><td> <textarea name="tags" rows=2 style="width:100%%;">%(tags)s</textarea></td></tr>
</table>
<table border=0>
<tr><input type="submit" value="Сохранить изменения"></tr>
</form>
'''

patient_id = 0
patient = None
 	
if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    patient_id = theform.getfirst('patient_id', 0)
if patient_id == 0: print body % 'No patient selected.'
else:

    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    cursor.execute('SELECT * FROM patients WHERE id=%s' % patient_id)
    
    patient=cursor.fetchone()
                
    connection.close()

if patient==None: print body % 'No patient selected.'   
else:
    patient_data = {}
    patient_data['patient_id'] = patient_id
    patient_data['surname'] = patient[1].replace('"', '&#34').encode('utf-8')
    patient_data['name'] =  patient[2].replace('"', '&#34').encode('utf-8')
    patient_data['otchestvo'] = patient[3].replace('"', '&#34').encode('utf-8')

    patient_data['male']=patient_data['female']=patient_data['nogender']=''
    if patient[4]=='м': patient_data['male']='selected="selected"'
    elif patient[4]=='ж': patient_data['female']='selected="selected"'
    else: patient_data['nogender']='selected="selected"' 

    day = patient[5][6:8]
    month = patient[5][4:6]
    year = patient[5][0:4]
    
    patient_data['dateform'] = date_form(int(year), int(month), int(day))
    
    patient_data['adres'] = unicode(patient[6]).encode('utf-8')
    patient_data['telefon'] = unicode(patient[7]).replace('"', '&#34').encode('utf-8')
    patient_data['diagnosis'] = unicode(patient[8]).encode('utf-8')
    patient_data['tags'] = unicode(patient[9]).encode('utf-8')
    patient_data['comments'] = unicode(patient[10]).encode('utf-8')

    form = patient_form % patient_data

    print body % form
    
    
