#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'

mainpage = '''<html><head><title>Сохранение данных</title>
<script language="JavaScript" type="text/JavaScript">
function place_patient(pat){
	parent.exams.location.href = "patient_display.py?patient_id=" + pat;
}
</script>
<meta http-equiv="refresh" content="1; URL=patient_edit.py?patient_id=%s">\n</head>
<body onload="place_patient(%s)">%s</body></html>'''
error = '''<h1>Error</h1><h2>No Form Submission Was Received</h2>'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                # finish headers with blank line

    theform = cgi.FieldStorage()
    patient_data = {}
    patient_data['patient_id'] = string_filter(theform.getfirst('patient_id', '0'))
    patient_data['surname'] = string_filter(theform.getfirst('surname', ''))
    patient_data['name'] = string_filter(theform.getfirst('name', ''))
    patient_data['otchestvo'] = string_filter(theform.getfirst('otchestvo', ''))
    patient_data['gender'] = string_filter(theform.getfirst('gender', '-'))
    
    year = string_filter(theform.getfirst('year', '1900'))
    month = string_filter(theform.getfirst('month', '01'))
    day = string_filter(theform.getfirst('day', '01'))

    patient_data['birthdate'] = year + month + day

    patient_data['adres'] = string_filter(theform.getfirst('adres', ''))
    patient_data['telefon'] = string_filter(theform.getfirst('telefon', ''))
    patient_data['diagnosis'] = string_filter(theform.getfirst('diagnosis', ''))
    patient_data['tags'] = string_filter(theform.getfirst('tags', ''))
    patient_data['comments'] = string_filter(theform.getfirst('comments', ''))


    
    
    con = sqlite.connect('patients.db')
    cur = con.cursor()
        
    update_data = '''UPDATE patients SET 
        surname = "%(surname)s",
        name = "%(name)s",
        otchestvo = "%(otchestvo)s",
        gender = "%(gender)s",
        birthdate = "%(birthdate)s",
        adres = "%(adres)s",
        telefon = "%(telefon)s",
        diagnosis = "%(diagnosis)s",
        tags = "%(tags)s",
        comments ="%(comments)s"
        WHERE id=%(patient_id)s'''

    if patient_data['patient_id']!=0: cur.execute(update_data % patient_data)
    con.commit()
    con.close() 

    print mainpage % (patient_data['patient_id'], patient_data['patient_id'], 'Исследование добавляется, подождите...')
    
