#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'
body = '''<html><head><title>Список врачей</title></head><body>%s</body></html>'''

script='''<script language="JavaScript" type="text/JavaScript">
function physician_kill(id){
	document.location.href = "physicians.py?kill=" + id;
}
</script>
'''


form='''
<form name="add" action="physicians.py" method="post">
Добавить врача: &nbsp <input type="text" name="physician">
<input type="submit" value="Добавить врача">
</form>
'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    physician = string_filter(theform.getfirst('physician', ''))
    kill = string_filter(theform.getfirst('kill', ''))    
    connection = sqlite.connect('config.db')
    cursor = connection.cursor()

    if kill!='':
        cursor.execute('SELECT * FROM config WHERE id=%s' % kill)
        fetch=cursor.fetchone()
        if fetch!=None: 
            if fetch[1]=='physician':
                cursor.execute('DELETE FROM config WHERE id=%s' % kill)
        connection.commit()

    
    if physician!='': 
        cursor.execute('INSERT INTO config VALUES (null, "physician", "%s")' % physician)
        connection.commit()

    cursor.execute('SELECT * FROM config WHERE user="physician"')
    physicians = cursor.fetchall()
    connection.close()
    

    if physicians==[]: print body % (form+'<p>Врачей нет')
    else:
        print '<html><head><title>Список врачей</title>'
        print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
        print script
        print '</head><body>' 
        print form, '<table><tr><th>Фамилия, инициалы</th><th>.</th></tr>'
        for phys in physicians:
            print '<tr><td>', phys[2].encode('utf-8'), '</td><td onclick="physician_kill(%s)">Удалить</td></tr>' % phys[0]
        print '</table></body></html>'

