#!c:/python26/python
# -*- coding: utf-8 -*-
try:
  import sqlite3 as sqlite
except:
  import sqlite
import sys
import cgi
from time import gmtime, strftime


try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def rtf(s=''):
    if type(s)==type(u''): u=s
    else: u=unicode(s, 'utf-8')
    rtfs=''
    for c in u:
        if ord(c)>128:
            rtfs=rtfs+"\\u%d\\'3f" % ord(c)
        else:
            rtfs=rtfs+c
    return str(rtfs)


cgiprint('Content-Type: text/rtf; charset=utf-8') #"Content-Type: text/rtf")
cgiprint("Content-Disposition: attachment; filename=report.rtf")
cgiprint()

body='''{\\rtf1\\utf-8\\deff1\\deflang3081
{\\fonttbl{\\f0\\froman\\fprq2\\fcharset0 Liberation Serif{\\*\\falt Times New Roman};}{\\f1\\fswiss\\fprq2\\fcharset0 Arial;}{\\f2\\fswiss\\fprq2\\fcharset0 Arial;}{\\f2\\fswiss\\fprq2\\fcharset0 Liberation Sans{\\*\\falt Arial};}{\\f4\\fswiss\\fprq2\\fcharset0 DejaVu Sans;}}
{\\colortbl;\\red0\\green0\\blue0;\\red128\\green128\\blue128;}
{\\stylesheet{\\s1\\sb60\\sa60\\rtlch\\af1\\afs22\\lang255\\ltrch\\dbch\\af1\\langfe3081\\hich\\f1\\fs22\\lang3081\\loch\\f1\\fs22\\lang3081\\snext1 Normal;}
{\\s2\\sb240\\sa120\\keepn\\rtlch\\af3\\afs28\\lang255\\ltrch\\dbch\\af4\\langfe3081\\hich\\f3\\fs28\\lang3081\\loch\\f3\\fs28\\lang3081\\sbasedon1\\snext3 Heading;}}
{\\header{\\pard\\qc\\plain\\b\\f0\\fs32%(hospital)s\\par}
{\\pard\\qc\\plain\\f1\\fs20%(adres)s\\par}}
{\\footer\\pard\\qr\\plain\\f0\\u1089\\'3f\\u1090\\'3f\\u1088\\'3f\\u1072\\'3f\\u1085\\'3f\\u1080\\'3f\\u1094\\'3f\\u1072\\'3f \\chpgn\\par}
%(text)s}
'''
paragraph='{\\pard\\ql\\plain\\fs21\\keep %s\\par}\n'


if __name__ == '__main__':
    theform = cgi.FieldStorage()
    room=theform.getfirst('room', '')

    query = 'SELECT * FROM patients JOIN inpatients ON patients.id=inpatients.patient_id WHERE inpatients.discharged=0'
    if room!='': query = query + ' AND inpatients.room="%s"' % room

    con=sqlite.connect('patients.db')
    cur=con.cursor()
    cur.execute(query)
    data = cur.fetchall()
    con.close()
    
    paragraphs=[]
    for row in data:
        fio = ' '.join(row[1:4]).encode('utf-8')
        location = row[14].encode('utf-8') + ', ' + unicode(row[15]).encode('utf-8')
        if row[17]==None: orders = 'Назначения' 
        else: orders = (row[17].encode('utf-8')).replace('\n', '\\line ')
        paragraphs.append(paragraph % rtf('{\\b '+fio+'}, \n{\\i'+location+' }\\line\n'+orders))
    header={}
    header['hospital']=rtf('Назначения')
    header['adres']=rtf('Распечатано в: %s' % strftime("%a, %d %b %Y %H:%M:%S +0000", gmtime()))
    header['text']='\\par '.join(paragraphs)
    print body % header



