#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import time
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           



contentheader = 'Content-Type: text/html; charset=utf-8'

mainpage = '''<html><head><title>Сохранение исследования</title>
<meta http-equiv="refresh" content="1; URL=exam_edit.py?patient_id=%s&exam_id=%s">\n</head>
<script language="JavaScript" type="text/JavaScript">
function place_patient(pat){
	parent.exams.location.href = "patient_display.py?patient_id=" + pat;
}
</script>
<body onload="place_patient(%s)">%s</body></html>'''
error = '''<h1>Error</h1><h2>No Form Submission Was Received</h2>'''






if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                # finish headers with blank line

    theform = cgi.FieldStorage()
    data=[]

    patient_id = theform.getfirst('patient_id', '0')

    ltime=time.localtime()
    year = ltime.tm_year
    day = ltime.tm_mday
    month = ltime.tm_mon

    examdate='%04d%02d%02d' % (year, month, day) 

    name = 'консультация'
   
    con = sqlite.connect('patients.db')
    cur = con.cursor()
        
    insert_data = '''INSERT INTO examinations (id, patient_id, examdate, name, contents, deleted)
                             values (null, %s, "%s", "%s", "%s", 5)'''

    cur.execute('SELECT surname, name, otchestvo, birthdate FROM patients WHERE id=%s' % patient_id)
    patient = cur.fetchone()
    fio = ' '.join(patient[0:3]).encode('utf-8')

    yo=(int(examdate)-int(patient[3]))/10000

    
    months=['января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', \
	'сентября', 'октября', 'ноября', 'декабря']

    data = examdate[6:8] + ' ' + months[int(examdate[4:6])-1] + ' ' + examdate[0:4] + ' г.\n'
    let = ', ' + str(yo) + ' ' + ['лет','год','года','года','года','лет','лет','лет','лет','лет'][yo%10]+'\n\n'


    cur.execute(insert_data % (patient_id, examdate, name, data+fio+let+'\n'))
    con.commit()
    cur.execute('SELECT id FROM examinations WHERE patient_id=%s AND deleted=5' % patient_id)
    added_study = cur.fetchone()
    if added_study!=None: exam_id=added_study[0]
    else: exam_id=''
    cur.execute('UPDATE examinations SET deleted=0 WHERE deleted=5')
    con.commit()
    con.close() 

    print mainpage % (patient_id, exam_id, patient_id, 'Исследование добавляется, подождите...')
    
