#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import time
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

theform = cgi.FieldStorage()
patient_id=theform.getfirst("patient_id", 0)

con=sqlite.connect('config.db')
cur=con.cursor()

cur.execute('SELECT * FROM forms')
forms = cur.fetchall()

cur.execute('SELECT param FROM config WHERE user="physician"')
physicians = [phys[0].encode('utf-8') for phys in cur.fetchall()]

con.close()


print '<html><head></head><body>\n<form name="form" action="form_main.py" method="post">\n'
print '<input type="hidden" name="patient_id" value=%s>' % patient_id

print 'Выберите вид исследования: &nbsp <select name="form_id">\n'

for form in forms:
    print ('<option value=%s>' % form[0] + form[1] + '</option>\n').encode('utf-8')

print '</select>'

ltime=time.localtime()
year = ltime.tm_year
day = ltime.tm_mday
month = ltime.tm_mon


option='<option value="%s">%s</option>'
selected_option='<option value="%s" selected="selected">%s</option>'

year_options=''
month_options=''
day_options=''
months=['января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', \
	'сентября', 'октября', 'ноября', 'декабря']

for i in range(year-10, year+1):
    if i == year: year_options=year_options+ selected_option % (i,i)
    else: year_options=year_options+ option % (i,i)

for i in range(1,13):
    if i == month: month_options=month_options+ selected_option % ('%02d' % i, months[i-1])
    else: month_options=month_options+ option % ('%02d' % i,months[i-1])

for i in range(1,32):
    if i==day: day_options = day_options + selected_option % ('%02d' % i, i)
    else: day_options = day_options + option % ('%02d' % i, i)

print '<br>Выберите дату исследования: &nbsp'
print '<select name="day">', day_options, '</select>'
print '<select name="month">', month_options, '</select>'
print '<select name="year">', year_options, '</select>'

print '<br>Врач: &nbsp '
print '<select name="physician">'
for phys in physicians:
    print '<option value="%s">%s</option>' % (phys, phys)
print '</select><br>'

print '<input type="submit" value="Добавить исследование">\n</form>'
print '</body></html>'
 

