#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite

import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'
body = '''<html><head>
<script type="text/javascript">
function saveOn()
  {
  document.getElementById('saved').disabled=false;
  }
function wanttosave()
  {
  if (document.getElementById('saved').disabled==false)
    {
    r=confirm("Сохранить изменения?");
    if (r==true)
      {
      document.getElementById('savebutton').click();
      }
    }
  }
function saveOff()
  {
  document.getElementById('saved').disabled=true;
  }
</script>
</head><body>%s</body></html>'''
form_begin='''<form name="form" action="exam_update.py" method="post">
 <input type="text" name="name" style="width:100%;" value="'''
form_mid='">\n<input type="hidden" name="exam_id" value=%s><input type="hidden" name="patient_id" value=%s>'
textarea='''<textarea id="txta" onBlur="wanttosave()" onChange="saveOn()" name="contents" rows=30 style="width:100%; height:70%">'''
form_end = '''</textarea>\n%s\n<input type="submit" id="savebutton" value="Сохранить изменения">
<input type="button" value="Удалить" onclick="parent.edit.location='exam_kill.py?exam_id=%s&patient_id=%s'">
<br><a href="rtf_output.py?exam_id=%s"><input type="button" value="Распечатать"></a>
</form><input type="checkbox" id="saved" disabled>'''


exam = None
exam_id = -1

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    patient_id = theform.getfirst('patient_id', 0)
    if patient_id == 0: print body % 'No patient selected.'
    exam_id = theform.getfirst('exam_id', 0)

if exam_id!=-1 and exam_id!=0:
    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    cursor.execute('SELECT * FROM examinations WHERE id=%s' % exam_id)
    
    exam=cursor.fetchone()
    cursor.execute('SELECT surname, name, otchestvo, birthdate FROM patients WHERE id=%s' % patient_id)
    patient=cursor.fetchone()            
    connection.close()

if patient_id!=0 and exam_id==0:
    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    cursor.execute('SELECT * FROM examinations WHERE patient_id=%s AND deleted=0 ORDER BY id DESC' % patient_id)
    
    exam=cursor.fetchone()
    cursor.execute('SELECT surname, name, otchestvo, birthdate FROM patients WHERE id=%s' % patient_id)
    patient=cursor.fetchone()            
    connection.close()
    if exam!=None: exam_id=exam[0]


if exam!=None:    
    year=int(exam[2][0:4])
    month=int(exam[2][4:6])
    day=int(exam[2][6:8])

    physician=exam[5]
    
    option='<option value="%s">%s</option>'
    selected_option='<option value="%s" selected="selected">%s</option>'

    year_options=''
    month_options=''
    day_options=''
    months=['января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', \
	'сентября', 'октября', 'ноября', 'декабря']

    for i in range(year-10, year+1):
        if i == year: year_options=year_options+ selected_option % (i,i)
        else: year_options=year_options+ option % (i,i)

    for i in range(1,13):
        if i == month: month_options=month_options+ selected_option % ('%02d' % i, months[i-1])
        else: month_options=month_options+ option % ('%02d' % i, months[i-1])

    for i in range(1,32):
        if i==day: day_options = day_options + selected_option % ('%02d' % i, i)
        else: day_options = day_options + option % ('%02d' % i, i)

    date_form='<br><select name="day">' + day_options + '</select>\n' + \
     '<select name="month">' + month_options + '</select>\n' + \
     '<select name="year">' + year_options + '</select>\n'
    

    if physician==None: physician=''
    physicians = 'Врач: &nbsp<input type="text" name="physician" value="%s"><br>' % physician.strip().encode('utf-8')

    form = form_begin + exam[3].encode('utf-8') + (form_mid % (exam_id, patient_id)) + date_form + textarea + exam[4].encode('utf-8') + form_end % (physicians, exam_id, patient_id, exam_id)

    print body % form
    
if exam==None: print body % 'Исследование не выбрано'
    
