#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite

import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'

mainpage = '''<html><head><title>Сохранение исследования</title>
<script language="JavaScript" type="text/JavaScript">
function place_patient(pat){
	parent.exams.location.href = "patient_display.py?patient_id=" + pat;
}
</script>
<meta http-equiv="refresh" content="1; URL=exam_edit.py?patient_id=%s&exam_id=%s">\n</head>
<body onload="place_patient(%s)">%s</body></html>'''
error = '''<h1>Error</h1><h2>No Form Submission Was Received</h2>'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                # finish headers with blank line

    theform = cgi.FieldStorage()

    patient_id = theform.getfirst('patient_id', '0')
    exam_id = theform.getfirst('exam_id', '0')
    name = string_filter(theform.getfirst('name', 'noname'))
    day = string_filter(theform.getfirst('day', '01'))
    month = string_filter(theform.getfirst('month', '01'))
    year = string_filter(theform.getfirst('year', '1900'))
    contents = string_filter(theform.getfirst('contents', 'empty'))
    tags = string_filter(theform.getfirst('tags', ''))
    physician = string_filter(theform.getfirst('physician', ''))
    
    con = sqlite.connect('patients.db')
    cur = con.cursor()
        
    update_data = '''UPDATE examinations SET name="%s", examdate="%s", contents="%s", physician="%s", tags="%s"\
         WHERE id=%s AND patient_id=%s'''

    cur.execute(update_data % (name, year+month+day, contents, physician, tags, exam_id, patient_id))
    con.commit()
    con.close() 

    print mainpage % (patient_id, exam_id, patient_id, 'Исследование добавляется, подождите...')
    
