#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi
import urllib

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'


thepage = '''<html><head></head><body>
<h2>Разделы</h2>
%s
</body></html>
'''


if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    
    theform = cgi.FieldStorage()
    
    form_id = theform.getfirst('form_id', 0)
    patient_id = theform.getfirst('patient_id', 0)
    examdate = theform.getfirst('examdate', 19000101)
    physician = theform.getfirst('physician', '')

    args = urllib.urlencode({'patient_id':patient_id, 'form_id':form_id, 'examdate':examdate, 'physician':physician})


    connection = sqlite.connect('config.db')
    cursor = connection.cursor()
    
    cursor.execute('SELECT contents FROM forms WHERE id=%s' % form_id) 
    
    contents=cursor.fetchone()[0]
    connection.close()
    
    f=contents.split('\n')

    heading = '<a target="contents" href="form_converter.py?'+args
    location ='#%s">%s</a><br>'


    headings=[]
    i = 1
    for line in f: 
        if line!='':
            if line[0]=='{':
                headings.append(heading + location % (i, line[1:]))
                i = i + 1

    navigation = '\n'.join(headings)

    print thepage % navigation.encode('utf-8')

