#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line


connection = sqlite.connect('config.db')
cursor = connection.cursor()

theform = cgi.FieldStorage()
structure = theform.getfirst('structure', '')
structure = structure.replace('<', '(').replace('>', ')')

new_title = theform.getfirst('title', '')
new_subtitle = theform.getfirst('subtitle', '')

# get title from config, update it if needed, create if not exists
cursor.execute('SELECT param FROM config WHERE user="title"')
title=cursor.fetchone()
if title==None:
    cursor.execute('INSERT INTO config (user, param) values ("title", "%s")' % string_filter(new_title))
    connection.commit()
else:
    if new_title!='': 
        cursor.execute('UPDATE config SET param="%s" WHERE user="title"' % string_filter(new_title))
        connection.commit()
cursor.execute('SELECT param FROM config WHERE user="title"')
title=cursor.fetchone()[0]

# get subtitle from config, update it if needed, create if not exists
cursor.execute('SELECT param FROM config WHERE user="subtitle"')  
subtitle=cursor.fetchone()
if subtitle==None:
    cursor.execute('INSERT INTO config (user, param) values ("subtitle", "%s")' % string_filter(new_subtitle))
    connection.commit()
else:
    if new_subtitle!='': 
        cursor.execute('UPDATE config SET param="%s" WHERE user="subtitle"' % string_filter(new_subtitle))
        connection.commit()
cursor.execute('SELECT param FROM config WHERE user="subtitle"')
subtitle=cursor.fetchone()[0]


if structure!='':
    cursor.execute('drop table if exists hospital')
    cursor.execute('CREATE TABLE hospital(ward TEXT, room TEXT)')

    wards=(structure.replace('\r\n', '\n').replace('\r', '\n')).split('\n')
    for ward in wards:
        w = ward.split(':')
        wardname = w[0].replace('"', '""').replace("'", "''")
        if len(w) > 1: 
            rooms = w[1].strip().split(' ')
            for r in rooms:
                r = r.replace('"', '""').replace("'", "''")
                query = 'INSERT INTO hospital VALUES ("%s", "%s")' % (string_filter(wardname), string_filter(r))
                cursor.execute(query)
            connection.commit()
        else: rooms = 'norooms'
    
cursor.execute('SELECT * FROM hospital')
rooms = cursor.fetchall()
roomselect=''
wards=set([r[0] for r in rooms])
for w in wards:
     roomselect=roomselect + w + ': '+\
             ' '.join([r[1] for r in filter(lambda x: x[0]==w, rooms)]) + '\n' 

    
connection.close()

form = '''<form name="form" action="/cgi-bin/hospital_config.py" method="post">
<h2>Название ЛПУ</h2>
<h3>Заголовок (название)</h3>
<textarea name="title" style="width:50%%; height:10%%">%s</textarea></br>
<h3>Подзаголовок (адрес)</h3>
<textarea name="subtitle" style="width:50%%; height:10%%">%s</textarea></br>
<h2>Структура стационара</h2>
<textarea name="structure" style="width:50%%; height:20%%">%s</textarea></br>
Название отделения, двоеточие, затем названия палат через пробел</br>
Пример заполнения:</br>
Терапевтическое отделение: ПИТ, 1 2 3 4 5 6</br>
Хирургическое отделение: 1 2 3 4 5 6 7 8 9 10, послеоперационная</br>
<input type="submit" value="Сохранить">
</form>'''

print '''<html><title>Структура стационара</title><body><h1>Структура стационара</h1>
  %s </body></html>''' % (form % (title.encode('utf-8'), subtitle.encode('utf-8'), roomselect.encode('utf-8')))
