#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

print sys.version

connection = sqlite.connect('patients.db')
cursor = connection.cursor()

create_inpatients = '''CREATE TABLE inpatients(
	id INTEGER PRIMARY KEY,
	patient_id INT not null,
	ward INT,
	room INT,
	admission INT,
	orders TEXT,
	problems TEXT,
	physician TEXT,
	discharged INT,
	status INT
	)
'''


cursor.execute('drop table if exists inpatients')

cursor.execute(create_inpatients)
cursor.close()

connection.commit()
connection.close()


con=sqlite.connect('config.db')
cur=con.cursor()


create_hospital = '''CREATE TABLE hospital(
    ward TEXT,
    room TEXT
    )
'''
cur.execute('drop table if exists hospital')

cur.execute(create_hospital)
con.commit()
con.close()
