#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import cgi
import sys

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'
displaydetails='''<script language="JavaScript" type="text/JavaScript">
function displayDetails(id){
	parent.details.location.href = "hospital_patient_info.py?patient_id=" + id;
}
</script>
'''



if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line
    
    theform = cgi.FieldStorage()
    room = theform.getfirst('room', '')

    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    query = 'SELECT * FROM patients JOIN inpatients ON patients.id=inpatients.patient_id WHERE inpatients.discharged=0'

    cursor.execute(query)

    data = cursor.fetchall()
    connection.close()
    
    search=''    

    print '<html><head>'
    print '<title>Список пациентов</title>'
    print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
    print '</head>'
    print '<body>', displaydetails
    print '<table><tr><th>Ф. И. О., возраст (%s)</th><th>Отделение, палата</th>' % len(data)
    
    rowhead = '''<tr onmouseover="this.style.backgroundColor='#BED9FB';" \
       onmouseout = "this.style.backgroundColor='#E5E5E5';" onclick="displayDetails(%d)">'''    

    for row in data:
#        for k in range(len(row)): print k, (row[k],), row[14].encode('utf-8'), '</br>'
        print rowhead % row[0]
        print ('<td>'+' '.join(row[1:4])+'</td>').encode('utf-8')
        print '<td>', row[14].encode('utf-8') + ', ', unicode(row[15]).encode('utf-8'), '</td>'



    
    cgiprint('</table></body></html>')


