#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import cgi
import sys

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

def string_filter(s=''):
    return s.replace('"', '""').replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;').replace('\r', '')


contentheader = 'Content-Type: text/html; charset=utf-8'



if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line
    
    theform = cgi.FieldStorage()
    room = string_filter(theform.getfirst('room', ''))
    saved = string_filter(theform.getfirst('saved', '0'))

    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()

    for i in range(int(saved)):
      p_id = string_filter(theform.getfirst('%s' % i, '-1'))
      if i==-1: print 'Erroneous data!'
      orders = string_filter(theform.getfirst('ord%s' % p_id, 'Назначения'))
      problems = string_filter(theform.getfirst('pr%s' % p_id, 'Проблемы'))
      query = 'UPDATE inpatients SET orders="%s", problems="%s" WHERE patient_id=%s' % (orders, problems, p_id)
      cursor.execute(query)
    connection.commit()

    query = 'SELECT * FROM patients JOIN inpatients ON patients.id=inpatients.patient_id WHERE inpatients.discharged=0'
    if room!='': query = query + ' AND inpatients.room="%s"' % room

    

    cursor.execute(query)

    data = cursor.fetchall()
    connection.close()
    
    search=''    

    print '<html><head>'
    print '<title>Стационар: назначения</title>'
    print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
    print '</head>'
    print '<body>'
    
    rooms = set([row[15] for row in data])
    for r in rooms:
        print '<form action="hospital_patients_rx.py"><button name="room" value="%s" type=submit>%s</button>&#09;' % (unicode(r).encode('utf-8'), unicode(r).encode('utf-8'))
    print '<button type=submit>Все палаты</button>'
    print '<a href="rtf_output_orders.py?room=%s"><input type="button" value="Распечатать"></a>' % room 
    print '</form><p>'

    print '<form action="hospital_patients_rx.py" method="post">'
    num=0

    if room!='': print '<input type="hidden" name="room" value="%s">' % room   # передать room при перезагрузке
    print '<input type="hidden" name="saved" value=%s>' % len(data) # number of patients transferred
    for row in data:
        print '<a href = "patient_main.py?patient_id=%s">'% row[0], ' '.join(row[1:4]).encode('utf-8')+ '</a><br>', row[14].encode('utf-8') + ',', unicode(row[15]).encode('utf-8'), '<p><p>'


        print '<input type="hidden" name="%s" value="%s">' % (num, row[0])  # patient's id transferred
        print '<textarea rows=10 style="width:33%%" name="ord%s">' % row[0]
        if row[17]==None: print 'Назначения' + '</textarea>'
        else: print row[17].encode('utf-8') + '</textarea>'
        print '<textarea rows=10 style="width:33%%" name="pr%s">' % row[0]
        if row[18]==None: print 'План обследования, проблемы' + '</textarea>'
        else: print row[18].encode('utf-8') + '</textarea>'
        print '<button type="submit">Сохранить</button><p>' 
        num=num+1

    print '</form>'
    
    print('</table></body></html>')


