#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi
try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'

page_begin='''<html>
<head>
<title>%s</title>
</head>'''
frames_begin='<frameset cols="50%,50%">'
frames='''<frame name="exams" src="patient_display.py?patient_id=%s">
<frame name="edit" src="exam_edit.py?patient_id=%s&exam_id=%s">'''

page_end='''</frameset>

</html>'''

if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    
    patient_id = theform.getfirst('patient_id', 1)
    exam_id = theform.getfirst('exam_id', 0)
    
    con=sqlite.connect('patients.db')
    cur=con.cursor()
    cur.execute('SELECT surname, name, otchestvo FROM patients WHERE id=%s' % patient_id)
    patient_names = cur.fetchone()
    if patient_names==None: patient='No patient selected'
    else: patient=' '.join(patient_names)
    if exam_id==0:
        cur.execute('SELECT id FROM examinations WHERE patient_id=%s AND deleted=0 ORDER BY examdate DESC, id DESC' % patient_id)
        exam=cur.fetchone()
        if exam!=None: exam_id=exam[0]
    
    con.close()

    print (page_begin % patient + frames_begin + frames % (patient_id, patient_id, exam_id) + page_end).encode('utf-8')


