#!c:/python26/python
# -*- coding: utf-8 -*-
import sqlite3 as sqlite
import sys
import cgi

try: 
    import cgitb
    cgitb.enable()
except ImportError:
    sys.stderr = sys.stdout

def cgiprint(inline=''):
    sys.stdout.write(inline)
    sys.stdout.write('\r\n')
    sys.stdout.flush()           

contentheader = 'Content-Type: text/html; charset=utf-8'
body = '''<html><head><title></title></head><body>%s</body></html>'''
script='''<script language="JavaScript" type="text/JavaScript">
function place_exam(pat, ex){
	parent.edit.location.href = "exam_edit.py?patient_id=" + pat + "&exam_id=" + ex;
}
</script>
'''

query='''SELECT patients.id, patients.surname, patients.name, patients.otchestvo,
examinations.id, examinations.name, examinations.examdate, examinations.physician
FROM patients
INNER JOIN examinations
ON patients.id=examinations.patient_id
WHERE patients.deleted=0 AND examinations.deleted=0
ORDER BY examinations.examdate DESC'''


if __name__ == '__main__':
    cgiprint(contentheader)   # content header
    cgiprint()                       # finish headers with blank line

    theform = cgi.FieldStorage()
    
    connection = sqlite.connect('patients.db')
    cursor = connection.cursor()
    cursor.execute(query)
    exams = cursor.fetchall()
    connection.close()
    print '<html><head>'
    print '<title></title>'
    print '<link rel="StyleSheet" href="/css/tablecloth.css" type="text/css">'
    print script
    print '</head>'
    print '<body>'
    print '<table><tr><th>Ф.И.О.</th><th>(%s)</th><th>Дата</th><th>Врач</th><th>' % len(exams)
    
    rowhead = '''<tr onmouseover="this.style.backgroundColor='#BED9FB';" \
           onmouseout = "this.style.backgroundColor='#E5E5E5';" onclick="place_exam(%s, %s)">'''    

    for exam in exams:
        print rowhead % (exam[0], exam[4])
        print ('<td>' + ' '.join(exam[1:4]) + '</td>').encode('utf-8')
        if exam[5]!=None: print ('<td>' + exam[5] + '</td>').encode('utf-8')
        if exam[6]!=None: print ('<td>' + exam[6][6:8]+'/'+exam[6][4:6]+'/'+exam[6][0:4] + '</td>').encode('utf-8')
        if exam[7]!=None: print ('<td>' + exam[7] + '</td>').encode('utf-8')
    print '</table></body></html>'

